#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/ioctl.h>

#define BLIT(fd)	ioctl((fd), _IO('d', 0))
#define DISPLAY(fd, x)	ioctl((fd), _IOW('d', 1, int), (x))

int main(int argc, char *argv[])
{
	int fd,fd2;
	caddr_t dmap;
	int i = 0, j = 0, l = 0;
	char *input;
	char cBuffer[ 4096 ];
	char dBuffer[ 5700 ];
	char input2[ 5557 ];
	char c[1];
	char *t;
	char cLeft = 0, cRight = 0;
	int cIndex = 0, dIndex = 0;
	
	if ( argc < 2 )
		{
		read(STDIN_FILENO,input2,sizeof(input2));
		input=input2;
		}
	else input=argv[1];
	fd = open("/dev/display", O_RDWR);
	if(fd == -1)
		return 1;

	fd2 = open("ascii.raw", O_RDONLY);
	if(fd2 == -1)
		return 1;
	if( read( fd2, dBuffer, 5700 ) == -1 )
		return -1;
	for( i = 0; i < 4096; i++ )
		cBuffer[i]=0;
	for( t = input; (t < (strlen(input) + input)) && l<4096; t++ )
		{
		strncpy(c, t, 1);
		dIndex=((int)*c - 32)*6;
		if ( dIndex < 0 || dIndex > 564 )
			cIndex=122;
		else
			{
			for (i=0; i < 10; i++)
				{
				for (j=0; j < 6; j++)
					cBuffer[cIndex+l+j+(i*128)]=
						dBuffer[dIndex+j+(i*570)];
				}
			}
		cIndex+=6;
		if ( cIndex > 122 )
			{
			l+=1408;
			cIndex=0;
			}
		}

	dmap = mmap(0, 2048, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0);
	if (dmap == (caddr_t) -1)
		return 2;

	// shuffle bits
	j=0;
	for( i = 0; i < 4096; i+=2, ++j )
	{
		cLeft = cBuffer[ i ] >> 6;
		cRight = cBuffer[ i+1 ] >> 6;
		dmap[ j ] = (cRight << 4) | cLeft;
	}

	BLIT(fd);
	DISPLAY(fd, 1);

	if (munmap(dmap, 2048) == -1 || close(fd) == -1)
		return 3;

	return 0;
}
